From mailer-daemon@brunel.ac.uk Fri Apr 30 15:19:57 1993
Return-Path: <stg@oikos.warwick.ac.uk>
Received: from violet.csv.warwick.ac.uk by sirius.brunel.ac.uk with SMTP (PP) 
          id <14909-0@sirius.brunel.ac.uk>; Fri, 30 Apr 1993 15:19:38 +0100
Received: from clover.csv.warwick.ac.uk by violet.csv.warwick.ac.uk with SMTP 
          id AA14057; Fri, 30 Apr 1993 15:19:10 +0100
Received: from thunnus.warwick.ac.uk (thunnus.oikos.warwick.ac.uk) 
          by clover.csv.warwick.ac.uk with SMTP id AA21117;
          Fri, 30 Apr 1993 15:19:07 +0100
From: Steve Gaito <stg@oikos.warwick.ac.uk>
Received: from salmo.warwick.ac.uk (salmo.oikos.warwick.ac.uk) 
          by thunnus.warwick.ac.uk; Fri, 30 Apr 93 15:20:10+010
Message-Id: <25676.9304301420@salmo.warwick.ac.uk>
Subject: Re: void pointers
To: cs89ssg@brunel.ac.uk (Sunil Gupta)
Date: Fri, 30 Apr 93 15:20:15 MET
In-Reply-To: <604.9304301342@ccws-16.brunel.ac.uk>; from "Sunil Gupta" at Apr 30, 93 2:42 pm
X-Mailer: ELM [version 2.3 PL8]
Status: OR

> 
> I'd like to be able to store a void pointer in a a suit object? anyone know
> how?
> -- 
> 

I wrote this code a while ago and as far as I know it works (I use it often
-=- however I don't remember if this is all that is needed... you are welcome
to try it!)

It is modeled on the the suit code from deftypes.c.

-- 
Stephen Gaito,	Ecosystems Analysis and Management Group, Biological Sciences,
		Univ.  of Warwick, Coventry, CV4 7AL ---
		Phone: +44 (203) 524456
		Email: stg@oikos.warwick.ac.uk
		Email: stg@uk.ac.warwick.oikos (on JANET)

--------------------------cut here-------------------------

/* (C) 1990 Copyright Rector and Visitors of the University of Virginia */

#ifndef EXTENDEDSUIT_INCLUDED
#define EXTENDEDSUIT_INCLUDED 1

#ifdef	MAKE_TEST_CODE
#ifndef	myDEBUG
#define	myDEBUG
#endif
#endif

#ifndef	myDebug
#ifdef	myDEBUG
#define	myDebug(message, args...) { fprintf(stderr,message, ## args); fflush(stderr); }
#else
#define	myDebug(message, args...)
#endif
#endif

#ifndef	PRIVSUIT_INCLUDED
#include	<suit.h>
#include	<srgp.h>
#endif

#endif 

--------------------------and cut here-------------------------
/* (C) Copyright 1990, 1991, 1992 the University of Virginia */

#define	myDebug(message)
/*{ printf message; fflush(stdout); }*/

#include "suitx.h"

/*--------------------------------------------------------*/
/*   VoidPTR data type					  */

void SUITx_setVoidPTR (SUIT_object obj, char *name, void *PTRvalue)
{
    ASSERT ((obj != NULL), (mes, "SUITx_setVoidPTR was called with a NULL object.  Use SUIT_deluxeSetProperty to set global properties.\n"));
    SUIT_setProperty (obj, name, "void*", (Pointer) &PTRvalue, OBJECT);
}

void *SUITx_getVoidPTR (SUIT_object obj, char *name)
{
    return (  (* (void **) SUIT_getProperty (obj, name, "void*") ) );
}


PRIVATE Pointer ReadVoidPTR (char *unused, boolean *error)
{
    ASSERT (FALSE, (mes, "Cannot read this application's .sui file as it contains a reference to a\n\
*     property of type void*.  The last time this application was executed this\n\
*     property must have been made permanent, thereby causing all the data associated\n\
*     with it to be saved to the .sui file upon exit.  Properties of type void*\n\
*     MUST be temporary."));

    *error = TRUE;
    return NULL;
}


PRIVATE char *WriteVoidPTR (Pointer unused)
{
    return "void*";
}


PRIVATE
int CompareVoidPTR(Pointer aVoidPTR1, Pointer aVoidPTR2)
{
	return (*(void**)aVoidPTR1) - (*(void**)aVoidPTR2);
}

PRIVATE
void DestroyVoidPTR(Pointer aVoidPTR)
{
	SUIT_free(aVoidPTR);
}


PRIVATE
Pointer CopyVoidPTR(Pointer aVoidPTR)
{
	void **result = SUIT_malloc(sizeof(void*));
	*result = (*(void**)aVoidPTR);
	return (Pointer) result;
}

PRIVATE
Pointer	DefaultVoidPTR(void) { return (Pointer) 0; };

void	SUITx_InitVoidPTRType (void)
{
	myDebug("SUITx_InitVoidPTRType\n");

	SUIT_registerType("void*",ReadVoidPTR,WriteVoidPTR,
		      CompareVoidPTR, DestroyVoidPTR,
		      CopyVoidPTR, DefaultVoidPTR,
		      (char*) NULL);
}


