/* (C) Copyright 1990, 1991, 1992 the University of Virginia */

#define	myDebug(message)
/*{ printf message; fflush(stdout); }*/

#include "suitx.h"

/*--------------------------------------------------------*/
/*   VoidPTR data type					  */

void SUITx_setVoidPTR (SUIT_object obj, char *name, void *PTRvalue)
{
    ASSERT ((obj != NULL), (mes, "SUITx_setVoidPTR was called with a NULL object.  Use SUIT_deluxeSetProperty to set global properties.\n"));
    SUIT_setProperty (obj, name, "void*", (Pointer) &PTRvalue, OBJECT);
}

void *SUITx_getVoidPTR (SUIT_object obj, char *name)
{
    return (  (* (void **) SUIT_getProperty (obj, name, "void*") ) );
}


PRIVATE Pointer ReadVoidPTR (char *unused, boolean *error)
{
    ASSERT (FALSE, (mes, "Cannot read this application's .sui file as it contains a reference to a\n\
*     property of type void*.  The last time this application was executed this\n\
*     property must have been made permanent, thereby causing all the data associated\n\
*     with it to be saved to the .sui file upon exit.  Properties of type void*\n\
*     MUST be temporary."));

    *error = TRUE;
    return NULL;
}


PRIVATE char *WriteVoidPTR (Pointer unused)
{
    return "void*";
}


PRIVATE
int CompareVoidPTR(Pointer aVoidPTR1, Pointer aVoidPTR2)
{
	return (*(void**)aVoidPTR1) - (*(void**)aVoidPTR2);
}

PRIVATE
void DestroyVoidPTR(Pointer aVoidPTR)
{
	SUIT_free(aVoidPTR);
}


PRIVATE
Pointer CopyVoidPTR(Pointer aVoidPTR)
{
	void **result = (void **)SUIT_malloc(sizeof(void*));
	*result = (*(void**)aVoidPTR);
	return (Pointer) result;
}

PRIVATE
Pointer	DefaultVoidPTR(void) { return (Pointer) 0; };

void	SUITx_InitVoidPTRType (void)
{
	myDebug("SUITx_InitVoidPTRType\n");

	SUIT_registerType("void*",ReadVoidPTR,WriteVoidPTR,
		      CompareVoidPTR, DestroyVoidPTR,
		      CopyVoidPTR, DefaultVoidPTR,
		      (char*) NULL);
}


